Index: /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LCSAdaptedGeneticAlgorithm.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LCSAdaptedGeneticAlgorithm.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LCSAdaptedGeneticAlgorithm.cs	(revision 9226)
@@ -95,4 +95,6 @@
     }
     #endregion
+
+    private CheckGASubsumptionOperator checkGASubsumptionOperator;
 
     [StorableConstructor]
@@ -155,5 +157,5 @@
       Assigner setSubsumpByAssigner = new Assigner();
       Assigner setSubsumptionFalseAssigner = new Assigner();
-      CheckGASubsumptionOperator checkGASubsumptionOperator = new CheckGASubsumptionOperator();
+      checkGASubsumptionOperator = new CheckGASubsumptionOperator();
       ConditionalBranch doGASubsumptionBranch2 = new ConditionalBranch();
       ExecuteGASubsumptionOperator executeGAsubsumptionOperator = new ExecuteGASubsumptionOperator();
@@ -199,6 +201,4 @@
       doGASubsumptionBranch1.ConditionParameter.ActualName = DoGASubsumptionParameter.ActualName;
 
-      checkGASubsumptionOperator.ChildClassifiersParameter.ActualName = "CombinedIntegerVector";
-      checkGASubsumptionOperator.ParentsClassifiersParameter.ActualName = "CombinedIntegerVector";
       checkGASubsumptionOperator.NumerositiesParameter.ActualName = "Numerosity";
       checkGASubsumptionOperator.ExperiencesParameter.ActualName = "Experience";
@@ -283,4 +283,9 @@
       return base.Apply();
     }
+
+    public void SetChildName(string childName) {
+      checkGASubsumptionOperator.ChildClassifiersParameter.ActualName = childName;
+      checkGASubsumptionOperator.ParentsClassifiersParameter.ActualName = childName;
+    }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs	(revision 9226)
@@ -79,4 +79,6 @@
     private CoveringOperator covering;
     private CountNumberOfUniqueActions countNumberOfUniqueActions;
+    private MatchActionOperator matchActionOperator;
+    private InsertInPopulationOperator insertInPopulation;
 
     private LCSAdaptedGeneticAlgorithm adaptedGeneticAlgorithmMainLoop;
@@ -130,5 +132,5 @@
       actionSelector = new ActionSelector();
       UniformSubScopesProcessor matchActionSubScopesProcessor = new UniformSubScopesProcessor();
-      MatchActionOperator matchActionOperator = new MatchActionOperator();
+      matchActionOperator = new MatchActionOperator();
       ConditionalSelector conditionMatchSelector = new ConditionalSelector();
       ConditionalSelector actionMatchSelector = new ConditionalSelector();
@@ -165,5 +167,5 @@
       UniformSubScopesProcessor setDeletionFalseSubScopeProcessor2 = new UniformSubScopesProcessor();
       Assigner setDeletionFalseAssigner = new Assigner();
-      InsertInPopulationOperator insertInPopulation = new InsertInPopulationOperator();
+      insertInPopulation = new InsertInPopulationOperator();
       XCSDeletionOperator deletionOperatorAfterGA = new XCSDeletionOperator();
       ConditionalSelector deletionSelectorAfterGA = new ConditionalSelector();
@@ -205,12 +207,7 @@
       iterationCounter.IncrementParameter.ActualName = "OneIntValue";
 
-      matchConditionOperator.MatchParameter.ActualName = "CombinedIntegerVector";
-
       conditionMatchSelector.CopySelected = new BoolValue(false);
       conditionMatchSelector.ConditionParameter.ActualName = matchConditionOperator.MatchConditionParameter.ActualName;
 
-      countNumberOfUniqueActions.ClassifiersParameter.ActualName = "CombinedIntegerVector";
-
-      doDeletionBeforeCovering.ClassifiersParameter.ActualName = "CombinedIntegerVector";
       doDeletionBeforeCovering.MatchConditionParameter.ActualName = matchConditionOperator.MatchConditionParameter.ActualName;
       doDeletionBeforeCovering.CurrentPopulationSizeParameter.ActualName = "CurrentPopulationSize";
@@ -242,8 +239,5 @@
       matchActionSubScopesProcessor.Operator = matchActionOperator;
 
-      matchActionOperator.MatchParameter.ActualName = "CombinedIntegerVector";
       matchActionOperator.TargetMatchParameter.ActualName = actionSelector.SelectedActionParameter.ActualName;
-
-      predictionArrayCalculator.MatchParameter.ActualName = "CombinedIntegerVector";
 
       actionSelector.PredictionArrayParameter.ActualName = predictionArrayCalculator.PredictionArrayParameter.Name;
@@ -321,5 +315,4 @@
       currentPopulationSizeCounter.Increment = new IntValue(2);
 
-      insertInPopulation.ClassifiersParameter.ActualName = "CombinedIntegerVector";
       insertInPopulation.NumerositiesParameter.ActualName = "Numerosity";
       insertInPopulation.HasToBeDeletedParameter.ActualName = HASTOBEDELETED;
@@ -462,4 +455,13 @@
 
       countNumberOfUniqueActions.ClassifierComparerParameter.ActualName = problem.ClassifierComparerParameter.Name;
+
+      matchConditionOperator.MatchParameter.ActualName = problem.ChildName;
+      countNumberOfUniqueActions.ClassifiersParameter.ActualName = problem.ChildName;
+      doDeletionBeforeCovering.ClassifiersParameter.ActualName = problem.ChildName;
+      matchActionOperator.MatchParameter.ActualName = problem.ChildName;
+      predictionArrayCalculator.MatchParameter.ActualName = problem.ChildName;
+      insertInPopulation.ClassifiersParameter.ActualName = problem.ChildName;
+
+      adaptedGeneticAlgorithmMainLoop.SetChildName(problem.ChildName);
     }
     //private void ParameterizeSelectors() {
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs	(revision 9226)
@@ -21,5 +21,4 @@
 
 using System;
-using System.Collections.Generic;
 using System.Linq;
 using System.Text;
@@ -264,55 +263,4 @@
       return true;
     }
-
-    public override bool Equals(object obj) {
-      return base.Equals(obj);
-    }
-
-    public override int GetHashCode() {
-      return base.GetHashCode();
-    }
-
-    [StorableClass]
-    [Item("CombinedIntegerVectorComparer", "")]
-    public class CombinedIntegerVectorComparer : Item, IEqualityComparer<CombinedIntegerVector>, IClassifierComparer {
-
-      [StorableConstructor]
-      protected CombinedIntegerVectorComparer(bool deserializing) : base(deserializing) { }
-      protected CombinedIntegerVectorComparer(CombinedIntegerVectorComparer original, Cloner cloner)
-        : base(original, cloner) {
-      }
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new CombinedIntegerVectorComparer(this, cloner);
-      }
-      public CombinedIntegerVectorComparer() : base() { }
-
-      public bool Equals(CombinedIntegerVector x, CombinedIntegerVector y) {
-        for (int i = 0; i < x.array.Length; i++) {
-          if (!x.array[i].Equals(y.array[i])) {
-            return false;
-          }
-        }
-        return true;
-      }
-
-      public int GetHashCode(CombinedIntegerVector obj) {
-        int result = obj.actionLength;
-        for (int i = 0; i < obj.array.Length; i++) {
-          result ^= obj.array[i];
-        }
-        return result.GetHashCode();
-      }
-
-      public bool Equals(IAction x, IAction y) {
-        var xCast = x as CombinedIntegerVector;
-        var yCast = y as CombinedIntegerVector;
-        return x != null && y != null && Equals(xCast, yCast);
-      }
-
-      public int GetHashCode(IAction obj) {
-        var objCast = obj as CombinedIntegerVector;
-        return objCast != null ? GetHashCode(objCast) : obj.GetHashCode();
-      }
-    }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorComparer.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorComparer.cs	(revision 9226)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorComparer.cs	(revision 9226)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.CombinedIntegerVectorEncoding {
+  [StorableClass]
+  [Item("CombinedIntegerVectorComparer", "")]
+  public class CombinedIntegerVectorComparer : Item, IEqualityComparer<CombinedIntegerVector>, IClassifierComparer {
+
+    [StorableConstructor]
+    protected CombinedIntegerVectorComparer(bool deserializing) : base(deserializing) { }
+    protected CombinedIntegerVectorComparer(CombinedIntegerVectorComparer original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CombinedIntegerVectorComparer(this, cloner);
+    }
+    public CombinedIntegerVectorComparer() : base() { }
+
+    public bool Equals(CombinedIntegerVector x, CombinedIntegerVector y) {
+      var xEnumerator = x.GetEnumerator();
+      var yEnumerator = y.GetEnumerator();
+      //xMove and yMove are used to check if both enumerators moved
+      bool xMove = xEnumerator.MoveNext();
+      bool yMove = yEnumerator.MoveNext();
+      while (xMove && yMove && xEnumerator.Current == yEnumerator.Current) {
+        xMove = xEnumerator.MoveNext();
+        yMove = yEnumerator.MoveNext();
+      }
+      return !xMove && !yMove;
+    }
+
+    public int GetHashCode(CombinedIntegerVector obj) {
+      int result = obj.ActionLength;
+      foreach (var value in obj) {
+        result ^= value;
+      }
+      return result.GetHashCode();
+    }
+
+    public bool Equals(IAction x, IAction y) {
+      var xCast = x as CombinedIntegerVector;
+      var yCast = y as CombinedIntegerVector;
+      return x != null && y != null && Equals(xCast, yCast);
+    }
+
+    public int GetHashCode(IAction obj) {
+      var objCast = obj as CombinedIntegerVector;
+      return objCast != null ? GetHashCode(objCast) : obj.GetHashCode();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj	(revision 9226)
@@ -121,4 +121,5 @@
   <ItemGroup>
     <Compile Include="CombinedIntegerVector.cs" />
+    <Compile Include="CombinedIntegerVectorComparer.cs" />
     <Compile Include="CombinedIntegerVectorCreator.cs" />
     <Compile Include="CombinedIntegerVectorCrossover.cs" />
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs	(revision 9226)
@@ -25,4 +25,6 @@
 namespace HeuristicLab.Encodings.ConditionActionEncoding {
   public interface IConditionActionProblem : IHeuristicOptimizationProblem {
+    string ChildName { get; }
+
     IParameter ProblemDataParameter { get; }
     IConditionActionProblemData ProblemData { get; }
@@ -33,5 +35,4 @@
     IParameter ThetaMinimalNumberOfActionsParameter { get; }
 
-    IParameter PossibleActionsConcreteClassParameter { get; }
     IParameter PossibleActionsParameter { get; }
 
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Covering/VariableVectorCoveringCreator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Covering/VariableVectorCoveringCreator.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Covering/VariableVectorCoveringCreator.cs	(revision 9226)
@@ -29,5 +29,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.VariableVector.Covering {
+namespace HeuristicLab.Encodings.VariableVector {
   [Item("VariableVectorCoveringCreator", "Description missing")]
   [StorableClass]
@@ -63,10 +63,10 @@
     private IEnumerable<IVariable> CoverInput(VariableVectorInput input, VariableVectorCondition sample, IRandom random, double changeSymbolProbability) {
       var conditionVariables = new List<IVariable>();
-      if (!input.Order.SequenceEqual(sample.Order)) {
-        throw new ArgumentException("Sample and input do not contain the same variable names");
+      if (!sample.Keys.All(x => input.ContainsKey(x))) {
+        throw new ArgumentException("Input does not contain all variable names from sample");
       }
       foreach (var keyValuePair in sample) {
         IVariable variable = keyValuePair.Value.GetEmptyCopy();
-        variable.Cover(random, input[keyValuePair.Key].Value, changeSymbolProbability);
+        variable.Cover(random, input[keyValuePair.Key], changeSymbolProbability);
         conditionVariables.Add(variable);
       }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Creators/UniformRandomVariableVectorCreator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Creators/UniformRandomVariableVectorCreator.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Creators/UniformRandomVariableVectorCreator.cs	(revision 9226)
@@ -20,10 +20,9 @@
 #endregion
 
-using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.VariableVector.Creators {
+namespace HeuristicLab.Encodings.VariableVector {
   [Item("UniformRandomVariableVectorCreator", "Description missing")]
   [StorableClass]
@@ -46,5 +45,5 @@
 
     protected override VariableVector Create(IRandom random, VariableVector sampleVariableVector, double spreadPercentage) {
-      var result = new VariableVector(sampleVariableVector.Condition.Values.Select(x => x.GetEmptyCopy()), sampleVariableVector.Action.Values.Select(x => x.GetEmptyCopy()));
+      var result = sampleVariableVector.GetEmptyCopy();
       result.Randomize(random, spreadPercentage);
       return result;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Crossover/SinglePointCrossover.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Crossover/SinglePointCrossover.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Crossover/SinglePointCrossover.cs	(revision 9226)
@@ -27,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Encodings.VariableVector.Crossover {
+namespace HeuristicLab.Encodings.VariableVector {
   [Item("SinglePointCrossover", "Description missing")]
   [StorableClass]
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/HeuristicLab.Encodings.VariableVector-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/HeuristicLab.Encodings.VariableVector-3.3.csproj	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/HeuristicLab.Encodings.VariableVector-3.3.csproj	(revision 9226)
@@ -44,4 +44,5 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Common.Resources-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Data-3.3">
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
@@ -64,4 +65,5 @@
     <Reference Include="System" />
     <Reference Include="System.Core" />
+    <Reference Include="System.Drawing" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -79,4 +81,5 @@
     <Compile Include="Manipulator\UniformOnePositionInConditionManipulator.cs" />
     <Compile Include="Manipulator\UniformSomePositionManipulator.cs" />
+    <Compile Include="VariableVectorActionComparer.cs" />
     <Compile Include="VariableVectorCrossover.cs" />
     <Compile Include="VariableVectorManipulator.cs" />
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Manipulator/UniformOnePositionInConditionManipulator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Manipulator/UniformOnePositionInConditionManipulator.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Manipulator/UniformOnePositionInConditionManipulator.cs	(revision 9226)
@@ -56,9 +56,10 @@
       var keyEnumerator = condition.Order.GetEnumerator();
       int count = 0;
-      while (keyEnumerator.MoveNext() && count < condition.VirtualLength
-        && count < index && count + condition[keyEnumerator.Current].VirtualLength < index) {
+      keyEnumerator.MoveNext();
+      while (count < condition.VirtualLength && count < index && count + condition[keyEnumerator.Current].VirtualLength <= index) {
         count += condition[keyEnumerator.Current].VirtualLength;
+        keyEnumerator.MoveNext();
       }
-      condition[keyEnumerator.Current].Manipulate(random, input[keyEnumerator.Current].Value, index - count - 1);
+      condition[keyEnumerator.Current].Manipulate(random, input[keyEnumerator.Current], index - count);
       return child;
     }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Plugin.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Plugin.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Plugin.cs	(revision 9226)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Encodings.VariableVector {
-  [Plugin("HeuristicLab.Encodings.VariableVector", "3.3.7.9194")]
+  [Plugin("HeuristicLab.Encodings.VariableVector", "3.3.7.9204")]
   [PluginFile("HeuristicLab.Encodings.VariableVector-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Properties/AssemblyInfo.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Properties/AssemblyInfo.cs	(revision 9226)
@@ -55,3 +55,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.7.9194")]
+[assembly: AssemblyFileVersion("3.3.7.9204")]
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs	(revision 9226)
@@ -100,9 +100,9 @@
     }
 
-    public new DoubleVariable GetEmptyCopy() {
+    public override IVariable GetEmptyCopy() {
       return new DoubleVariable(variableName, min, max);
     }
-    public new DoubleVariable GetSetCopy() {
-      DoubleVariable copy = GetEmptyCopy();
+    public override IVariable GetSetCopy() {
+      DoubleVariable copy = (DoubleVariable)GetEmptyCopy();
       copy.CurrentCenter = this.CurrentCenter;
       copy.CurrentSpread = this.CurrentSpread;
@@ -153,5 +153,5 @@
       if (parent2Cast == null) { throw new ArgumentException("Argument is not of the correct type."); }
       if (pos > 1 || pos < 0) { throw new ArgumentOutOfRangeException(); }
-      DoubleVariable crossed = this.GetSetCopy();
+      DoubleVariable crossed = (DoubleVariable)this.GetSetCopy();
       if (pos == 0) {
         crossed.CurrentSpread = parent2Cast.CurrentSpread;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IActionVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IActionVariable.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IActionVariable.cs	(revision 9226)
@@ -20,8 +20,14 @@
 #endregion
 
+using System.Collections.Generic;
 
 namespace HeuristicLab.Encodings.VariableVector {
   // variables which can be used in the action
   public interface IActionVariable : IVariable {
+    new IActionVariable GetEmptyCopy();
+    new IActionVariable GetSetCopy();
+
+    void SetTo(string value);
+    IEnumerable<string> GetAllPossibleActions();
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs	(revision 9226)
@@ -63,4 +63,5 @@
       this.possibleFeatures = new List<int>(original.possibleFeatures);
       this.Wildcard = original.Wildcard;
+      this.currentValue = original.currentValue;
     }
     public IntVariable()
@@ -70,9 +71,10 @@
     public IntVariable(string variableName, IEnumerable<int> variableValues)
       : base(variableName) {
-      if (variableValues.Count() != variableValues.Distinct().Count()) {
-        throw new ArgumentException("variableValues have to be distinct.");
+      if (variableValues.Count() > 0 && variableValues.Count() != variableValues.Distinct().Count()) {
+        throw new ArgumentException("variableValues have to be distinct and there has to be at least one value.");
       }
       possibleFeatures = variableValues;
       Wildcard = false;
+      currentValue = possibleFeatures.First();
     }
     public IntVariable(string variableName, IEnumerable<int> variableValues, int currentValue)
@@ -102,12 +104,20 @@
     }
 
-    public new IntVariable GetEmptyCopy() {
+    public override IVariable GetEmptyCopy() {
       return new IntVariable(variableName, possibleFeatures);
     }
-    public new IntVariable GetSetCopy() {
-      IntVariable copy = GetEmptyCopy();
+
+    public override IVariable GetSetCopy() {
+      IntVariable copy = (IntVariable)GetEmptyCopy();
       copy.Wildcard = this.Wildcard;
       copy.CurrentValue = this.CurrentValue;
       return copy;
+    }
+
+    IActionVariable IActionVariable.GetEmptyCopy() {
+      return (IntVariable)GetEmptyCopy();
+    }
+    IActionVariable IActionVariable.GetSetCopy() {
+      return (IntVariable)GetSetCopy();
     }
 
@@ -143,5 +153,5 @@
       if (parent2Cast == null) { throw new ArgumentException("Argument is not of the correct type."); }
       if (pos != 0) { throw new ArgumentOutOfRangeException(); }
-      return this.GetSetCopy();
+      return (IntVariable)this.GetSetCopy();
     }
 
@@ -160,4 +170,25 @@
       }
     }
+
+    public override int GetHashCode() {
+      int result = 1;
+      int wildcardInt = Wildcard ? 1 : 0;
+      result = 37 * result + wildcardInt;
+      result = 37 * result + currentValue;
+      foreach (var feature in possibleFeatures) {
+        result = 37 * result + feature;
+      }
+      return result;
+    }
+
+    #region IActionVariable Members
+    public void SetTo(string value) {
+      currentValue = int.Parse(value);
+    }
+
+    public IEnumerable<string> GetAllPossibleActions() {
+      return possibleFeatures.Select(x => x.ToString());
+    }
+    #endregion
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs	(revision 9226)
@@ -74,4 +74,5 @@
       this.featureMapping = new Dictionary<int, string>(original.featureMapping);
       this.Wildcard = original.Wildcard;
+      this.currentValue = original.currentValue;
     }
     public StringVariable()
@@ -150,12 +151,18 @@
     }
 
-    public new StringVariable GetEmptyCopy() {
+    public override IVariable GetEmptyCopy() {
       return new StringVariable(variableName, featureMapping);
     }
-    public new StringVariable GetSetCopy() {
-      StringVariable copy = GetEmptyCopy();
+    public override IVariable GetSetCopy() {
+      StringVariable copy = (StringVariable)GetEmptyCopy();
       copy.Wildcard = this.Wildcard;
       copy.CurrentValue = this.CurrentValue;
       return copy;
+    }
+    IActionVariable IActionVariable.GetEmptyCopy() {
+      return (StringVariable)GetEmptyCopy();
+    }
+    IActionVariable IActionVariable.GetSetCopy() {
+      return (StringVariable)GetSetCopy();
     }
 
@@ -195,5 +202,5 @@
       if (parent2Cast == null) { throw new ArgumentException("Argument is not of the correct type."); }
       if (pos != 0) { throw new ArgumentOutOfRangeException(); }
-      return this.GetSetCopy();
+      return (StringVariable)this.GetSetCopy();
     }
 
@@ -202,6 +209,5 @@
       Wildcard = !Wildcard;
       if (!Wildcard) {
-        int newValue = featureMapping.First(x => x.Value.Equals(stringValue)).Key;
-        currentValue = newValue;
+        currentValue = featureMapping.First(x => x.Value.Equals(stringValue)).Key;
       }
     }
@@ -210,8 +216,29 @@
       Wildcard = random.NextDouble() < changeSymbolProbability;
       if (!Wildcard) {
-        int newValue = featureMapping.First(x => x.Value.Equals(stringValue)).Key;
-        currentValue = newValue;
-      }
-    }
+        currentValue = featureMapping.First(x => x.Value.Equals(stringValue)).Key;
+      }
+    }
+
+    public override int GetHashCode() {
+      int result = 1;
+      int wildcardInt = Wildcard ? 1 : 0;
+      result = 37 * result + wildcardInt;
+      result = 37 * result + currentValue;
+      foreach (var feature in featureMapping) {
+        result = 37 * result + feature.Key;
+        result = 37 * result + feature.Value.GetHashCode();
+      }
+      return result;
+    }
+
+    #region IActionVariable Members
+    public void SetTo(string value) {
+      currentValue = featureMapping.First(x => x.Value.Equals(value)).Key;
+    }
+
+    public IEnumerable<string> GetAllPossibleActions() {
+      return featureMapping.Values;
+    }
+    #endregion
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/Variable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/Variable.cs	(revision 9225)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/Variable.cs	(revision 9226)
@@ -52,6 +52,6 @@
     }
 
-    public virtual IVariable GetEmptyCopy() { throw new NotSupportedException("This method is not supported. It should be implemented by every non abstract class."); }
-    public virtual IVariable GetSetCopy() { throw new NotSupportedException("This method is not supported. It should be implemented by every non abstract class."); }
+    public abstract IVariable GetEmptyCopy();
+    public abstract IVariable GetSetCopy();
 
     public abstract void Randomize(IRandom random);
